/**
 *	ipgeolocation
 *
 *	(sven) neawolf - http://sourcecodes.pro
 *
 *	@author		(sven) neawolf
 *	@version	1.1
 *	@create		2012-06-08
 *	@update		2012-06-14
 *	@jquery		>= 1.6
 *
 *	@sources	map				: 	openstreetmap.org
 *				weather			:	worldweatheronline.com
 *				ip geodb - 1	:	freegeoip.net
 *				ip geodb - 2	:	geoplugin.net
 *				ip geodb - 3	:	ipinfodb.com
 *
 *	@apikey		Please create a free API key at:
 *									worldweatheronline.com
 *									ipinfodb.com
 *
 */
/*--------------------------------------------------------------------------------------------------------------------*/
/*--------------------------------------------------------------------------------------------------------------------*/

/*
*	ipgeolocation plugin
*/
(function($)
{
	$.fn.ipgeolocation = function(options){
		return this.each(function(){
			$.ipgeolocation(options);
		});
	};

/*--------------------------------------------------------------------------------------------------------------------*/
/*--------------------------------------------------------------------------------------------------------------------*/

/*
*	# parameters can be passed on to the website
*/
		$.ipgeolocation = function(options){
		
        /*** default settings ***/
				settings = $.extend({
						host				: undefined,		/*** host/ ip:   [undefined,   or: "sourcecodes.pro",   or: "213.251.170.82" ] (undefined = own ip) ***/
						width				: 700,				/*** map iframe + text output width   [default: 700] ***/
						height				: 300,				/*** map iframe height   [default: 300] ***/
						maptype				: 'mapnik',			/*** maptype:   [mapquest, mapnik, transportmap] ***/
						marker				: true,				/*** set marker to geo-position   [true, false] ***/
						square				: 0.07,				/*** area in square degrees   [default: 0.07] ***/
						view_data_map		: true,				/*** view map   [true, false] ***/
						view_data_loc		: true,				/*** view location text   [true, false] ***/
						view_data_whois		: true,				/*** view ip-lookup text   [true, false] ***/
						view_data_weather	: true,				/*** view weather text   [true, false] ***/ 
						element_border		: "1px solid #000000",	/*** element border style ***/
						background_color	: "#ffffff",		/*** textarea background color ***/
						font_color			: "#000000",		/*** textarea font color ***/
						font_family			: "Arial, Helvetica, sans-serif",	/*** textarea font family ***/
						font_size			: "11px",			/*** textarea font size ***/
						tableborder_color	: "#999999",		/*** textarea table border (right) color ***/
						apikey_ipinfodb		: "c64cf00e7806edd75ebf7ff5a884b0020abe25ca9e2cef39856e92f0e855f6ac",	/*** api.ipinfodb.com api key ***/
						apikey_weather		: "6a23e507f6140936121006",	/*** worldweatheronline.com api key ***/
					test:""
				},options);

/*-----*/
/*-----*/
				ipgeolocation_element = "ipgeolocation";		/*** form 'class' name ***/
				IPgeodata = [];
/*-----*/
/*-----*/

		

		
		



	/* data from (1.) freegeoip.net */
	function dataresult_freegeoip(settings) {
		if((settings.host == null) || (settings.host == undefined)){ settings.host = ""; }
		$.ajax ({
			url: "http://freegeoip.net/json/" + settings.host + "?",
			dataType: 'json',
			async: true,
			cache: true,
			crossDomain: true,
			timeout: 5000,
			success: function (data) {
				IPgeodata.ip 			= data.ip;
				IPgeodata.city			= data.city;
				IPgeodata.region_code	= data.region_code;
				IPgeodata.region_name	= data.region_name;
				IPgeodata.metrocode		= data.metrocode;
				IPgeodata.zipcode		= data.zipcode;
				IPgeodata.country_code	= data.country_code;
				IPgeodata.country_name	= data.country_name;
				IPgeodata.longitude		= data.longitude;
				IPgeodata.latitude		= data.latitude;
				IPgeodata.database		= "freegeoip.net";
					if(IPgeodata.latitude.toString().length >= 4){
						var IPgeodata_longitude=IPgeodata.longitude.toString().split(".");
							if(IPgeodata_longitude[1] == undefined){ IPgeodata_longitude[1] = "0"; }
						var IPgeodata_latitude=IPgeodata.latitude.toString().split(".");
							if(IPgeodata_latitude[1] == undefined){ IPgeodata_latitude[1] = "0"; }
						if((IPgeodata_longitude[1].length <= 2) || (IPgeodata_latitude[1].length <= 2)){
							dataresult_geoplugin(settings); //nächster Anbieter
						}else{
							//georesult(settings);
                            if (release) window.analytics.trackEvent('event', 'Location', 'freegeoip');
                            /******************************Statusmeldung***********************************/
                            popupNotification.show(ip_location_string, "error");
                            var position = new Object();
                            position.coords = new Object();
                            position.coords.latitude = IPgeodata.latitude;
                            position.coords.longitude= IPgeodata.longitude;
                            onSuccess(position);
						}
					}else{
						dataresult_geoplugin(settings); //nächster Anbieter
					}
			},
			error: function (xhr, textStatus, errorThrown) { dataresult_geoplugin(settings); }	
		});	
	}
		
	/* data from (2.) geoplugin.net */
	function dataresult_geoplugin(settings) {
		if((settings.host == null) || (settings.host == undefined)){ settings.host = ""; }
		$.ajax ({
			url: "http://sourcecodes.pro/georesult/geoplugin.html?ip=" + settings.host,
			dataType: 'json',
			async: true,
			cache: true,
			crossDomain: true,
			timeout: 5000,
			success: function (data) {
				IPgeodata.ip 			= data.geoplugin_request;
				IPgeodata.city			= data.geoplugin_city;
				IPgeodata.region_code	= data.geoplugin_region;
				IPgeodata.region_name	= data.geoplugin_regionName;
				IPgeodata.metrocode		= 0;
				IPgeodata.zipcode		= 0;
				IPgeodata.country_code	= data.geoplugin_countryCode;
				IPgeodata.country_name	= data.geoplugin_countryName;
				IPgeodata.longitude		= data.geoplugin_longitude;
				IPgeodata.latitude		= data.geoplugin_latitude;
				IPgeodata.database		= "geoplugin.net";
					if(IPgeodata.latitude.toString().length >= 4){
						var IPgeodata_longitude=IPgeodata.longitude.toString().split(".");
							if(IPgeodata_longitude[1] == undefined){ IPgeodata_longitude[1] = "0"; }
						var IPgeodata_latitude=IPgeodata.latitude.toString().split(".");
							if(IPgeodata_latitude[1] == undefined){ IPgeodata_latitude[1] = "0"; }
						if((IPgeodata_longitude[1].length <= 2) || (IPgeodata_latitude[1].length <= 2)){
							dataresult_ipinfodb(settings); //nächster Anbieter
						}else{
                            //georesult(settings);
                            if (release) window.analytics.trackEvent('event', 'Location', 'geoplugin');
                            /******************************Statusmeldung***********************************/
                            popupNotification.show(ip_location_string, "error");
                            var position = new Object();
                            position.coords = new Object();
                            position.coords.latitude = IPgeodata.latitude;
                            position.coords.longitude= IPgeodata.longitude;
                            onSuccess(position);
						}
					}else{
						dataresult_ipinfodb(settings); //nächster Anbieter
					}
			},
			error: function (xhr, textStatus, errorThrown) { dataresult_ipinfodb(settings); }	
		});	
	}	
	
	/* data from (3.) ipinfodb.com */
	function dataresult_ipinfodb(settings) {
		var IPGeolocation = new geolocate(false, true, settings.host);
			var callback = function(){
				IPgeodata.longitude		= IPGeolocation.getField('longitude');
				IPgeodata.latitude		= IPGeolocation.getField('latitude');
				IPgeodata.ip			= IPGeolocation.getField('ipAddress');
				IPgeodata.country_code	= IPGeolocation.getField('countryCode');
				IPgeodata.country_name	= IPGeolocation.getField('countryName');
				IPgeodata.region_name	= IPGeolocation.getField('regionName');
				IPgeodata.city			= IPGeolocation.getField('cityName');
				IPgeodata.zipcode		= IPGeolocation.getField('zipCode');
				IPgeodata.database		= "ipinfodb.com";
				
				if(IPgeodata.ip == undefined){
					//geoerror(settings);
                    if (release) window.analytics.trackEvent('error', 'no IP location');
                    /******************************Statusmeldung***********************************/
                    popupNotification.show(location_fail_string, "error");
				}else{
                    //georesult(settings);
                    if (release) window.analytics.trackEvent('event', 'Location', 'ipinfodb');
                    /******************************Statusmeldung***********************************/
                    popupNotification.show(ip_location_string, "error");
                    var position = new Object();
                    position.coords = new Object();
                    position.coords.latitude = IPgeodata.latitude;
                    position.coords.longitude= IPgeodata.longitude;
                    onSuccess(position);
				}
			};
		IPGeolocation.checkcookie(callback);
	}	
		
	
	
	

	
/*
*	# data result
*/	
	function georesult(settings) {
			/* map box area */		
			
			math_square_deg = parseFloat(settings.square);
			math_square_lon = math_square_deg;
			math_square_lat = (parseFloat(settings.square) / settings.width * settings.height );
			
			geo_lon_min = (parseFloat(IPgeodata.longitude) - parseFloat(math_square_lon.toFixed(4)));
				geo_lon_min = geo_lon_min.toFixed(4);
			geo_lon_max = (parseFloat(IPgeodata.longitude) + parseFloat(math_square_lon.toFixed(4)));
				geo_lon_max = geo_lon_max.toFixed(4);
			geo_lat_min = (parseFloat(IPgeodata.latitude) - parseFloat(math_square_lat.toFixed(4)));
				geo_lat_min = geo_lat_min.toFixed(4);
			geo_lat_max = (parseFloat(IPgeodata.latitude) + parseFloat(math_square_lat.toFixed(4)));
				geo_lat_max = geo_lat_max.toFixed(4);

			mapurl = "http://www.openstreetmap.org/export/embed.html?bbox="+geo_lon_min+","+geo_lat_min+","+geo_lon_max+","+geo_lat_max+"&amp;layer="+settings.maptype;
			if(settings.marker == true){ mapurl = mapurl+"&amp;marker="+IPgeodata.latitude+","+IPgeodata.longitude; }
			
		if ( $('.'+ipgeolocation_element).length <= 0 ) {
			$('<div class="'+ipgeolocation_element+'"> </div>').appendTo('body');
		}		
		$('.'+ipgeolocation_element).empty();
		
		$('.'+ipgeolocation_element)
				.css("width", settings.width + 'px')
				.css("border", settings.element_border);
		
		
		if(settings.view_data_map == true){
			$('<iframe id="'+ipgeolocation_element+'_iframe"></iframe>').appendTo('.'+ipgeolocation_element);
						$('#'+ipgeolocation_element+'_iframe')
							.css("clear", 'both')
							.css("z-index", '2000000001')
							.css("overflow", 'hidden')
							.css("margin", '0')
							.css("padding", '0')
							.css("border", '0')
							.css("width", settings.width + 'px')
							.css("min-width", settings.width + 'px')
							.css("height", settings.height + 'px')
							.css("min-height", settings.height + 'px')
						;	
			$('#'+ipgeolocation_element+'_iframe').attr("src",mapurl); 	
		}

		$('<div id="'+ipgeolocation_element+'_rawdata"></div>').appendTo('.'+ipgeolocation_element);
						$('#'+ipgeolocation_element+'_rawdata')
							.css("clear", 'both')
							.css("z-index", '2000000002')
							.css("overflow", 'hidden')
							.css("margin", '0')
							.css("padding", '0')
							.css("border", '0')
							.css("width", settings.width + 'px')
							.css("min-width", settings.width + 'px')
							.css("background-color", settings.background_color)
							.css("color", settings.font_color)
							.css("font-family", settings.font_family)
							.css("font-size", settings.font_size)
						;		

			
				var table_column = 0;
				if(settings.view_data_loc == true){ table_column = table_column + 1}
				if(settings.view_data_whois == true){ table_column = table_column + 1}
				if(settings.view_data_weather == true){ table_column = table_column + 1}
			
			var table_column_width = parseInt(parseFloat(settings.width) / parseInt(table_column));
			var table_column_width = parseInt(table_column_width - 2);
			
			/* geo location text */
			if(settings.view_data_loc == true){
			$('<table id="'+ipgeolocation_element+'_table_1"></table>').appendTo('#'+ipgeolocation_element+'_rawdata');
						$('#'+ipgeolocation_element+'_table_1')
							.css("float", 'left')
							.css("overflow", 'hidden')
							.css("margin", '0')
							.css("padding", '0')
							.css("border", '0')
							.css("width", table_column_width + 'px')
							.css("min-width", table_column_width + 'px')
							.css("max-width", table_column_width + 'px')
						;	
						if((settings.view_data_whois == true) || (settings.view_data_weather == true)){
							$('#'+ipgeolocation_element+'_table_1').css("border-right", '1px solid ' + settings.tableborder_color)
						}
					$('<tr><td> </td><td><b><u>IP Location</u></b></td></tr>').appendTo('#'+ipgeolocation_element+'_table_1');
				$('<tr><td>IP:</td><td>'+IPgeodata.ip+'</td></tr>').appendTo('#'+ipgeolocation_element+'_table_1');
				$('<tr><td>Longitude:</td><td>'+IPgeodata.longitude+'</td></tr>').appendTo('#'+ipgeolocation_element+'_table_1');
				$('<tr><td>Latitude:</td><td>'+IPgeodata.latitude+'</td></tr>').appendTo('#'+ipgeolocation_element+'_table_1');
				$('<tr><td>Country:</td><td>'+IPgeodata.country_name+' ('+IPgeodata.country_code+')</td></tr>').appendTo('#'+ipgeolocation_element+'_table_1');
				$('<tr><td>Region:</td><td>'+IPgeodata.region_name+'</td></tr>').appendTo('#'+ipgeolocation_element+'_table_1');
				$('<tr><td>City:</td><td>'+IPgeodata.city+'</td></tr>').appendTo('#'+ipgeolocation_element+'_table_1');
			}
			
			/* ip lookup text */
			if(settings.view_data_whois == true){
			$('<table id="'+ipgeolocation_element+'_table_2"></table>').appendTo('#'+ipgeolocation_element+'_rawdata');
						$('#'+ipgeolocation_element+'_table_2')
							.css("float", 'left')
							.css("overflow", 'hidden')
							.css("margin", '0')
							.css("padding", '0')
							.css("border", '0')
							.css("width", table_column_width + 'px')
							.css("min-width", table_column_width + 'px')
							.css("max-width", table_column_width + 'px')
						;				
						if(settings.view_data_weather == true){
							$('#'+ipgeolocation_element+'_table_2').css("border-right", '1px solid ' + settings.tableborder_color)
						}
					$('<tr><td> </td><td><b><u>IP Lookup</u></b></td></tr>').appendTo('#'+ipgeolocation_element+'_table_2');
						if ($.browser.msie && parseInt($.browser.version, 10) >= 7 && window.XDomainRequest) {
							// Use Microsoft XDR
							xdrL = new XDomainRequest();
							jQuery.support.cors = true;
							xdrL.open("get", 'http://sourcecodes.pro/georesult/geowhois.html?ip=' + IPgeodata.ip);
							xdrL.onload = function() {
							  json = 'json = '+xdrL.responseText;
							  eval(json);
							  parseJSON(json);
								IPgeodata.iplook_inetnum	= json.inetnum;
								IPgeodata.iplook_netname	= json.netname;
								IPgeodata.iplook_descr		= json.descr;
								IPgeodata.iplook_address_1	= json.address_1;
								IPgeodata.iplook_address_2	= json.address_2;
								IPgeodata.iplook_address_3	= json.address_3;
									$('<tr><td>Inetnum:</td><td>'+IPgeodata.iplook_inetnum+'</td></tr>').appendTo('#'+ipgeolocation_element+'_table_2');
									$('<tr><td>Netname:</td><td>'+IPgeodata.iplook_netname+'</td></tr>').appendTo('#'+ipgeolocation_element+'_table_2');
									$('<tr><td>Descr.:</td><td>'+IPgeodata.iplook_descr+'</td></tr>').appendTo('#'+ipgeolocation_element+'_table_2');
									$('<tr><td>Address:</td><td>'+IPgeodata.iplook_address_1+'</td></tr>').appendTo('#'+ipgeolocation_element+'_table_2');
									$('<tr><td></td><td>'+IPgeodata.iplook_address_2+'</td></tr>').appendTo('#'+ipgeolocation_element+'_table_2');
									$('<tr><td></td><td>'+IPgeodata.iplook_address_3+'</td></tr>').appendTo('#'+ipgeolocation_element+'_table_2');
							}
							xdrL.send();
						} else {
						$.ajax ({
							url: "http://sourcecodes.pro/georesult/geowhois.html?ip=" + IPgeodata.ip,
							dataType: 'json',
							async: true,
							cache: true,
							crossDomain: true,
							timeout: 5000,
							success: function (data) {
								IPgeodata.iplook_inetnum	= data.inetnum;
								IPgeodata.iplook_netname	= data.netname;
								IPgeodata.iplook_descr		= data.descr;
								IPgeodata.iplook_address_1	= data.address_1;
								IPgeodata.iplook_address_2	= data.address_2;
								IPgeodata.iplook_address_3	= data.address_3;
									$('<tr><td>Inetnum:</td><td>'+IPgeodata.iplook_inetnum+'</td></tr>').appendTo('#'+ipgeolocation_element+'_table_2');
									$('<tr><td>Netname:</td><td>'+IPgeodata.iplook_netname+'</td></tr>').appendTo('#'+ipgeolocation_element+'_table_2');
									$('<tr><td>Descr.:</td><td>'+IPgeodata.iplook_descr+'</td></tr>').appendTo('#'+ipgeolocation_element+'_table_2');
									$('<tr><td>Address:</td><td>'+IPgeodata.iplook_address_1+'</td></tr>').appendTo('#'+ipgeolocation_element+'_table_2');
									$('<tr><td></td><td>'+IPgeodata.iplook_address_2+'</td></tr>').appendTo('#'+ipgeolocation_element+'_table_2');
									$('<tr><td></td><td>'+IPgeodata.iplook_address_3+'</td></tr>').appendTo('#'+ipgeolocation_element+'_table_2');
							}
						});
						}			
			}
			
			/* weather text */
			if(settings.view_data_weather == true){
			$('<table id="'+ipgeolocation_element+'_table_3"></table>').appendTo('#'+ipgeolocation_element+'_rawdata');
						$('#'+ipgeolocation_element+'_table_3')
							.css("float", 'left')
							.css("overflow", 'hidden')
							.css("margin", '0')
							.css("padding", '0')
							.css("border", '0')
							.css("width", table_column_width + 'px')
							.css("min-width", table_column_width + 'px')
							.css("max-width", table_column_width + 'px')
						;				
					$('<tr><td> </td><td><b><u>Location Weather</u></b></td></tr>').appendTo('#'+ipgeolocation_element+'_table_3');
						if ($.browser.msie && parseInt($.browser.version, 10) >= 7 && window.XDomainRequest) {
							// Use Microsoft XDR
							xdrW = new XDomainRequest();
							jQuery.support.cors = true;
							xdrW.open("get", 'http://sourcecodes.pro/georesult/weather.html?key='+settings.apikey_weather+'&ip='+IPgeodata.ip);
							xdrW.onload = function() {
							  json = 'json = '+xdrW.responseText;
							  eval(json);
							  parseJSON(json);
								IPgeodata.ipweather_temp_c		= json.temp_C;
								IPgeodata.ipweather_temp_f		= json.temp_F;
								IPgeodata.ipweather_wind_kmh	= json.windspeedKmph;
								IPgeodata.ipweather_wind_mph	= json.windspeedMiles;
								IPgeodata.ipweather_wind_dir	= json.winddir16Point;
								IPgeodata.ipweather_cloudcover	= json.cloudcover;
								IPgeodata.visibility			= json.visibility;
								IPgeodata.localtime				= json.localtime;

									$('<tr><td>City:</td><td>('+IPgeodata.country_code+') '+IPgeodata.city+'</td></tr>').appendTo('#'+ipgeolocation_element+'_table_3');
									$('<tr><td>Temperature:</td><td>'+IPgeodata.ipweather_temp_c +'&deg;C &nbsp;&nbsp;&nbsp;('+IPgeodata.ipweather_temp_f +'&deg;F)</td></tr>').appendTo('#'+ipgeolocation_element+'_table_3');
									$('<tr><td>Wind:</td><td>'+IPgeodata.ipweather_wind_kmh+'kmh ('+IPgeodata.ipweather_wind_mph+'mph) from the '+IPgeodata.ipweather_wind_dir+'</td></tr>').appendTo('#'+ipgeolocation_element+'_table_3');
									$('<tr><td>Cloud Cover:</td><td>'+IPgeodata.ipweather_cloudcover +' %</td></tr>').appendTo('#'+ipgeolocation_element+'_table_3');
									$('<tr><td>Visibility:</td><td>'+IPgeodata.visibility +' km</td></tr>').appendTo('#'+ipgeolocation_element+'_table_3');
									$('<tr><td>Local Time:</td><td>'+IPgeodata.localtime	 +'</td></tr>').appendTo('#'+ipgeolocation_element+'_table_3');
							}
							xdrW.send();
						} else {
						$.ajax ({
							url: "http://sourcecodes.pro/georesult/weather.html?key="+settings.apikey_weather+"&ip="+IPgeodata.ip,
							dataType: 'json',
							async: true,
							cache: true,
							crossDomain: true,
							timeout: 5000,
							success: function (data) {
								IPgeodata.ipweather_temp_c		= data.temp_C;
								IPgeodata.ipweather_temp_f		= data.temp_F;
								IPgeodata.ipweather_wind_kmh	= data.windspeedKmph;
								IPgeodata.ipweather_wind_mph	= data.windspeedMiles;
								IPgeodata.ipweather_wind_dir	= data.winddir16Point;
								IPgeodata.ipweather_cloudcover	= data.cloudcover;
								IPgeodata.visibility			= data.visibility;
								IPgeodata.localtime				= data.localtime;

									$('<tr><td>City:</td><td>('+IPgeodata.country_code+') '+IPgeodata.city+'</td></tr>').appendTo('#'+ipgeolocation_element+'_table_3');
									$('<tr><td>Temperature:</td><td>'+IPgeodata.ipweather_temp_c +'&deg;C &nbsp;&nbsp;&nbsp;('+IPgeodata.ipweather_temp_f +'&deg;F)</td></tr>').appendTo('#'+ipgeolocation_element+'_table_3');
									$('<tr><td>Wind:</td><td>'+IPgeodata.ipweather_wind_kmh+'kmh ('+IPgeodata.ipweather_wind_mph+'mph) from the '+IPgeodata.ipweather_wind_dir+'</td></tr>').appendTo('#'+ipgeolocation_element+'_table_3');
									$('<tr><td>Cloud Cover:</td><td>'+IPgeodata.ipweather_cloudcover +' %</td></tr>').appendTo('#'+ipgeolocation_element+'_table_3');
									$('<tr><td>Visibility:</td><td>'+IPgeodata.visibility +' km</td></tr>').appendTo('#'+ipgeolocation_element+'_table_3');
									$('<tr><td>Local Time:</td><td>'+IPgeodata.localtime	 +'</td></tr>').appendTo('#'+ipgeolocation_element+'_table_3');
							}
						});	
						}			
			}			
		
	}
	




// JSON RegExp
var rvalidchars = /^[\],:{}\s]*$/;
var rvalidescape = /\\(?:["\\\/bfnrt]|u[0-9a-fA-F]{4})/g;
var rvalidtokens = /"[^"\\\n\r]*"|true|false|null|-?\d+(?:\.\d*)?(?:[eE][+\-]?\d+)?/g;
var rvalidbraces = /(?:^|:|,)(?:\s*\[)+/g;
var trimLeft = /^\s+/;
var trimRight = /\s+$/;
 
function trim( text ) {
	return text == null ?
		"" :
		text.toString().replace( trimLeft, "" ).replace( trimRight, "" );
};
 
function parseJSON( data ) {
	if ( typeof data !== "string" || !data ) {
		return null;
	}
	// Make sure leading/trailing whitespace is removed (IE can't handle it)
	data = trim( data );
	// Attempt to parse using the native JSON parser first
	if ( window.JSON && window.JSON.parse ) {
		return window.JSON.parse( data );
	}
	// Make sure the incoming data is actual JSON
	// Logic borrowed from http://json.org/json2.js
	if ( rvalidchars.test( data.replace( rvalidescape, "@" )
		.replace( rvalidtokens, "]" )
		.replace( rvalidbraces, "")) ) {
 		return (new Function( "return " + data ))();
 	}
	//jQuery.error( "Invalid JSON: " + data )    // i substituted this since we don't have jQuery in this example
	return false;
}




	function geoerror(settings) {
		alert('error - no data response');
	}	
	/* call first function */ 
	dataresult_freegeoip(settings);	
		
}
	})(jQuery);
/* EOF settings

/*--------------------------------------------------------------------------------------------------------------------*/
/*-----*/
/*--------------------------------------------------------------------------------------------------------------------*/





/*--------------------------------------------------------------------------------------------------------------------*/
/*-----*/
/*--------------------------------------------------------------------------------------------------------------------*/

/*
*	geolocate ipinfodb
*/

function geolocate(timezone, cityPrecision, ip) {
  var key = settings.apikey_ipinfodb;
  var api = (cityPrecision) ? "ip-city" : "ip-country";
  var domain = 'api.ipinfodb.com';
  var version = 'v3';
  var url = "http://" + domain + "/" + version + "/" + api + "/?key=" + key + "&format=json" + "&callback=?"
  var geodata;
  var JSON = JSON || {};
  
	if( (ip != null) && ip != "" ){
		url = url + "&ip=" + ip;
	}
  
  // implement JSON.stringify serialization
  JSON.stringify = JSON.stringify || function (obj) {
    var t = typeof (obj);
    if (t != "object" || obj === null) {
      // simple data type
      if (t == "string") obj = '"'+obj+'"';
        return String(obj);
    } else {
    // recurse array or object
      var n, v, json = [], arr = (obj && obj.constructor == Array);
      for (n in obj) {
        v = obj[n]; t = typeof(v);
        if (t == "string") v = '"'+v+'"';
        else if (t == "object" && v !== null) v = JSON.stringify(v);
        json.push((arr ? "" : '"' + n + '":') + String(v));
      }
      return (arr ? "[" : "{") + String(json) + (arr ? "]" : "}");
    }
  };
  
  // implement JSON.parse de-serialization
  JSON.parse = JSON.parse || function (str) {
    if (str === "") str = '""';
      eval("var p=" + str + ";");
      return p;
  };
  
  //Check if cookie already exist. If not, query IPInfoDB
  this.checkcookie = function(callback) {
    geolocationCookie = getCookie('geolocation');
    if (!geolocationCookie) {
      getGeolocation(callback);
    } else {
      geodata = JSON.parse(geolocationCookie);
      callback();
    }
  }
  
  //Return a geolocation field
  this.getField = function(field) {
    try {
      return geodata[field];
    } catch(err) {}
  }
  
  //Request to IPInfoDB
  function getGeolocation(callback) {
		$.ajax ({
			url: url,
			dataType: 'json',
			async: true,
			cache: true,
			crossDomain: true,
			timeout: 5000,
			success: function (data) {
				geodata = data;
				JSONString = JSON.stringify(geodata);
				setCookie('geolocation', JSONString, 365);
				callback();
			},
			error:function(xhr,err){ callback(); }
		});	
  }
  
  //Set the cookie
  function setCookie(c_name, value, expire) {
    var exdate=new Date();
    exdate.setDate(exdate.getDate()+expire);
    document.cookie = c_name+ "=" +escape(value) + ((expire==null) ? "" : ";expires="+exdate.toGMTString());
  }
  
  //Get the cookie content
  function getCookie(c_name) {
    if (document.cookie.length > 0 ) {
      c_start=document.cookie.indexOf(c_name + "=");
      if (c_start != -1){
        c_start=c_start + c_name.length+1;
        c_end=document.cookie.indexOf(";",c_start);
        if (c_end == -1) {
          c_end=document.cookie.length;
        }
        return unescape(document.cookie.substring(c_start,c_end));
      }
    }
    return '';
  }
}

/*--------------------------------------------------------------------------------------------------------------------*/
/*-----*/
/*--------------------------------------------------------------------------------------------------------------------*/

/*
*	EOF ipgeolocation Plugin
*/








